﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using HeuristicLab.Core;
using HeuristicLab.Data;
using HeuristicLab.Optimization.Operators.LCS;
using HeuristicLab.Problems.DataAnalysis;

namespace HeuristicLab.Encodings.DecisionList {
  public interface IDecisionListClassificationProblemData : IGAssistNichesProblemData {
    Dataset Dataset { get; }
    ICheckedItemList<StringValue> ConditionVariables { get; }
    StringValue TargetVariable { get; }
    IEnumerable<string> AllowedConditionVariables { get; }
    //IEnumerable<string> AllowedTargetVariables { get; }

    IntRange TrainingPartition { get; }
    IntRange TestPartition { get; }

    IEnumerable<int> TrainingIndices { get; }
    IEnumerable<int> TestIndices { get; }

    bool IsTrainingSample(int index);
    bool IsTestSample(int index);

    int Classes { get; }

    IValueParameter<Rule> SampleRuleParameter { get; }

    DecisionListInput FetchInput(int row);
    IEnumerable<DecisionListInput> FetchInput(IEnumerable<int> row);

    IEnumerable<IAction> FetchAction(IEnumerable<int> rows);
    IAction FetchAction(int rows);

    event EventHandler Changed;
  }
}
